<template>
  <v-select
    v-model="month"
    :items="months"
    item-value="month"
    item-text="title"
    solo
    flat
    @change="changeMonth(false)"
  >
    <template #selection="data">
      <span class="font-weight-bold">{{ data.item.title }}</span>
    </template>
  </v-select>
</template>

<script>
import * as moment from 'jalali-moment';

export default {
  name: "TaMonths",
  props: {
    type: {
      type: String,
      default: 'georgian'
    },
  },
  data() {
    return {
      months: [],
      month: 0,
      currentMonth: 0,
    }
  },
  computed: {
    calendarLocale() {
      return this.type === 'jalali' ? 'fa' : 'en'
    },
    isJalali() {
      return this.calendarLocale === 'fa'
    },
    year() {
      return moment().locale(this.calendarLocale).year()
    }
  },
  created() {
    /**
     * Set months
     */
    this.months = this.monthsCreator(this.calendarLocale)
    const month = moment().locale(this.calendarLocale).month()
    this.month = month
    this.currentMonth = month
    this.changeMonth(true)
    /**
     * Init date
     */
    this.$store.dispatch('date/setInit', true)
  },
  methods: {
    days(year, month, firstDay = false) {
      const isJalali = this.calendarLocale === 'fa'
      if (firstDay) {
        if (isJalali) {
          const fDay = moment(`${year}-${month}-01`, 'jYYYY-jM-jDD').locale(this.calendarLocale).isoWeekday()
          const persianWeekDays = {
            0: 2,
            1: 3,
            2: 4,
            3: 5,
            4: 6,
            5: 0,
            6: 1
          }
          return persianWeekDays[fDay]
        } else {
          return moment(`${year}-${month}-01`, 'YYYY-M-DD').locale(this.calendarLocale).isoWeekday()
        }
      } else if (isJalali)
        return moment(`${year}-${month}-01`, 'jYYYY-jM-jDD').locale(this.calendarLocale).jDaysInMonth()
      else
        return moment(`${year}-${month}-01`, 'YYYY-M-DD').locale(this.calendarLocale).daysInMonth()
    },
    monthsCreator(locale) {
      return Array.apply(0, Array(12)).map((_, i) => {
        return {
          month: i,
          title: moment().locale(locale).month(i).format('MMMM')
        }
      })
    },
    /**
     * Change date vuex
     */
    changeMonth(isCreated = false) {
      const month = this.month + 1
      const year = this.isJalali ? moment().locale(this.calendarLocale).jYear() : moment().locale(this.calendarLocale).year()
      let day = 1
      if (isCreated || month === (this.currentMonth + 1)) {
        if (this.isJalali) {
          day = moment().locale(this.calendarLocale).format('D')
        } else {
          day = moment().locale(this.calendarLocale).format('D')
        }
        day = parseInt(day)
      }
      const days = this.days(year, month)
      const firstDay = this.days(year, month, true)
      const weekDays = this.weekDays(days, firstDay)
      this.$store.dispatch('date/setDay', day)
      this.$store.dispatch('date/setMonth', month)
      this.$store.dispatch('date/setMonthTitle', this.months[month - 1].title)
      this.$store.dispatch('date/setYear', year)
      this.$store.dispatch('date/setDays', days)
      this.$store.dispatch('date/setMonthFirstDayWeek', {firstDay, days: weekDays})
    },
    /**
     * Make week days
     */
    weekDays(days, firstDay) {
      const isJalali = this.calendarLocale === 'fa'
      // day names
      const daysNames = isJalali ? ['شنبه', 'یک', 'دو', 'سه', 'چهار', 'پنج', 'جمعه'] : ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun']
      const weekDays = []
      let start = false
      let firstWeek = false
      let daysCount = 1
      const fDay = firstDay - 1
      /**
       * Set first day
       */
      if (!start) {
        weekDays.push(daysNames[fDay])
        if (fDay === 7)
          firstWeek = true
        start = true
        daysCount++
      }
      /**
       * Set first week
       */
      if (start && !firstWeek) {
        for (let d = fDay + 1; d < 7; d++) {
          weekDays.push(daysNames[d])
          daysCount++
        }
        firstWeek = true
      }
      /**
       * If first day and week is set
       */
      if (start && firstWeek) {
        let weekDaysCount = 0
        for (let wDay = daysCount; wDay <= days; wDay++) {
          weekDays.push(daysNames[weekDaysCount])
          weekDaysCount++
          if (weekDaysCount === 7) {
            weekDaysCount = 0
          }
        }
      }
      return weekDays
    }
  }
}
</script>
